package rabbit.meta;

// $Id: KillTheStupidThing.java,v 1.5 2005/08/01 12:43:45 robo Exp $

import java.io.*;
import java.net.*;
import java.util.Properties;

import rabbit.html.*;
import rabbit.http.*;
import rabbit.io.*;
import rabbit.proxy.*;
import rabbit.proxy.Proxy;

/** a metapage to stop the proxy in a nice way
 */
public class KillTheStupidThing implements MetaHandler {
    /** default constructor */
    public KillTheStupidThing () {
    }

    /** handler of a MetaPage, that is a special page the proxy supports (like the status page).
     * @param input the InputStream from the client.
     * @param output the OutputStream to the client.
     * @param header the http request header
     * @param htab the supplied argument to the page (CGI-parameters).
     * @param con the Connection that is serving the request.
     */
    public void handle (InputStream input, 
			MultiOutputStream output, 
			HTTPHeader header, 
			Properties htab, 
			Connection con) {
	try {
	    output.writeHTTPHeader (con.getResponseHandler ().getHeader ());
	    StringBuilder res = 
		new StringBuilder (HTMLPage.getPageHeader (con, "Killing the proxy..."));
	    res.append ("<p><p>At the time you read this, I am probably dead.\n</body></html>");
	    output.write (res.toString ().getBytes ());
	} catch (IOException e) {
	    con.getProxy ().logError ("Damn, couldnt write kill message to client");
	}
	con.getProxy ().kill ();
    }
}
