package rabbit.html;

// $Id: HTMLParseException.java,v 1.2 2005/05/05 15:29:16 robo Exp $

/** This exception indicates an error in the parsing of an HTML block.
 */
public class HTMLParseException extends Exception {
    private static final long serialVersionUID = 20050430;
   
    /** Create a new HTMLParseException with the given string.
     * @param s the reason for the exception.
     */
    public HTMLParseException (String s) {
	super (s);
    }
    
    /** Create a new HTMLParseException with the given Throwable.
     * @param t the reason for the exception.
     */
    public HTMLParseException (Throwable t) {
	super (t.toString ());
    }
}
