package rabbit.proxy;

// $Id: DNSSunHandler.java,v 1.3 2005/08/02 20:50:21 robo Exp $

import java.net.InetAddress;
import java.net.URL;
import java.net.UnknownHostException;

/** A DNS handler using the standard java packages.
 */
public class DNSSunHandler implements DNSHandler {
    /** Do any neccessary setup. */
    public void setup (Proxy proxy) {
	// empty.
    }

    /** Look up an internet address. */
    public InetAddress getInetAddress (URL url) throws UnknownHostException {
	return InetAddress.getByName (url.getHost ());
    }

    public InetAddress getInetAddress (String host) throws UnknownHostException {
	return InetAddress.getByName (host);
    }
}
