package rabbit.util;

// $Id: RestartableThreadFactory.java,v 1.3 2005/06/07 20:38:35 robo Exp $

/** An interface that describes a restartable thread factory.
 *  ThreadPool will use factories to create the thread as they are
 *  needed.
 */
public interface RestartableThreadFactory<T> {
    public T createThread ();
}
